<?php

// Extended database class
// Date: 2009-02-16


class Database extends mysqli
{
  var $Prefix = '';
  var $Functions = array('NOW()', 'CURDATE()', 'CURTIME()', 'UUID()');
  
  function query($Query)
  {
	  global $Config;
	
	  if($Config['Web']['ShowSQLQuery'] == true)
    {
	    if(isset($_SERVER['REMOTE_ADDR'])) echo('<div style="border-bottom-width: 1px; border-bottom-style: solid; padding-bottom: 3px; padding-top: 3px; font-size: 12px; font-family: Arial;">'.$Query.'</div>'); 
      else echo($Query."\n");
    }
	  $Result = parent::query($Query);
    if(($this->error != '') and ($Config['Web']['ShowSQLError'] == true)) 
    {
	    if(isset($_SERVER['REMOTE_ADDR'])) echo('<div><strong>SQL Error: </strong>'.$this->error.'<br />'.$Query.'</div>');
      echo('SQL Error: '.$this->error.' '.$Query."\n");
    }

    return($Result);  
  }

  function select($Table, $What = '*', $Condition = 1)
  {
    return($this->query('SELECT '.$What.' FROM `'.$this->Prefix.$Table.'` WHERE '.$Condition));  
  }

  function delete($Table, $Condition)
  {
    $this->query('DELETE FROM `'.$this->Prefix.$Table.'` WHERE '.$Condition);  
  }
  
  function insert($Table, $Data)
  {
    $Name = '';
    $Values = '';
    foreach($Data as $Key => $Value)
    {
      $Name .= ',`'.$Key.'`';
	    if(!in_array($Value, $this->Functions)) $Value = '"'.$this->real_escape_string($Value).'"';
      $Values .= ','.$Value;
    }
    $Name = substr($Name, 1);
    $Values = substr($Values, 1);
    $this->query('INSERT INTO `'.$this->Prefix.$Table.'` ('.$Name.') VALUES('.$Values.')'); 
  }
  
  function update($Table, $Condition, $Data)
  {
    $Values = '';
    foreach($Data as $Key => $Value)
    {
	    if(!in_array($Value, $this->Functions)) $Value = '"'.$this->real_escape_string($Value).'"';
      $Values .= ', `'.$Key.'`='.$Value;
    }
    $Values = substr($Values, 2);  
    $this->query('UPDATE `'.$this->Prefix.$Table.'` SET '.$Values.' WHERE ('.$Condition.')');
  }
  
  function replace($Table, $Data)
  {
    $Name = '';
    $Values = '';
    foreach($Data as $Key => $Value)
    {
	    if(!in_array($Value, $this->Functions)) $Value = '"'.$this->real_escape_string($Value).'"';
      $Name .= ',`'.$Key.'`';
      $Values .= ','.$Value;
    }
    $Name = substr($Name, 1);
    $Values = substr($Values, 1);
    //echo('REPLACE INTO `'.$this->Prefix.$Table.'` ('.$Name.') VALUES ('.$Values.')<br />');
    $this->query('REPLACE INTO `'.$this->Prefix.$Table.'` ('.$Name.') VALUES('.$Values.')');
    //echo($this->error().'<br>');
  }
  
  function charset($Charset)
  {
    $this->query('SET NAMES "'.$Charset.'"');
  }
}

?>
