<?php

$FormClasses = array(
  'UserOptions' => array(
    'Title' => 'Základní nastavení',
    'Table' => 'User',
    'SubmitText' => 'Uložit',
    'Items' => array(
      'Login' => array('Type' => 'String', 'Caption' => 'Přihlašovací jméno', 'Default' => ''),
      'Password' => array('Type' => 'Password', 'Caption' => 'Heslo', 'Default' => ''),
      'Name' => array('Type' => 'String', 'Caption' => 'Zobrazované jméno', 'Default' => ''),
      'Email' => array('Type' => 'String', 'Caption' => 'E-mail', 'Default' => ''),
      //'PhoneNumber' => array('Type' => 'String', 'Caption' => 'Telefón', 'Default' => ''),
      //'ICQ' => array('Type' => 'String', 'Caption' => 'ICQ', 'Default' => ''),
    ),
  ),
  'UserRegister' => array(
    'Title' => 'Registrace uživatele',
    'SubmitText' => 'Registrovat',
    'Table' => 'User',
    'Items' => array(
      'Login' => array('Type' => 'String', 'Caption' => 'Přihlašovací jméno', 'Default' => ''),
      'Password' => array('Type' => 'Password', 'Caption' => 'Heslo', 'Default' => ''),
      'Password2' => array('Type' => 'Password', 'Caption' => 'Potvrzení hesla', 'Default' => ''),
      'Name' => array('Type' => 'String', 'Caption' => 'Zobrazované jméno', 'Default' => ''),
      'Email' => array('Type' => 'String', 'Caption' => 'E-mail', 'Default' => ''),
      //'PhoneNumber' => array('Type' => 'String', 'Caption' => 'Telefón', 'Default' => ''),
      //'ICQ' => array('Type' => 'String', 'Caption' => 'ICQ', 'Default' => ''),
    ),
  ),
  'UserLogin' => array(
    'Title' => 'Přihlášení uživatele',
    'SubmitText' => 'Přihlásit',
    'Table' => '',
    'Items' => array(
      'Username' => array('Type' => 'String', 'Caption' => 'Přihlašovací jméno', 'Default' => ''),
      'Password' => array('Type' => 'Password', 'Caption' => 'Heslo', 'Default' => ''),
    ),
  ),
  'NewServer' => array(
    'Title' => 'Nový server',
    'Table' => 'Server',
    'SubmitText' => 'Registrovat',
    'Items' => array(
      'Name' => array('Type' => 'String', 'Caption' => 'Název', 'Default' => 'WoW server'),
      'Description' => array('Type' => 'Text', 'Caption' => 'Popis', 'Default' => ''),
      'Homepage' => array('Type' => 'String', 'Caption' => 'Webové stránky', 'Default' => ''),
      'Type' => array('Type' => 'TServerType', 'Caption' => 'Typ', 'Default' => 0),
      'Database' => array('Type' => 'TDatabase', 'Caption' => 'Databáze', 'Default' => 0),
      'Motd' => array('Type' => 'String', 'Caption' => 'Zpráva dne', 'Default' => 'Vítejte na free WoW serveru'),
    ),
  ),
  'EditServer' => array(
    'Title' => 'Nastavení',
    'Table' => 'Server',
    'SubmitText' => 'Uložit',
    'Items' => array(
      'Name' => array('Type' => 'String', 'Caption' => 'Název', 'Default' => 'WoW server'),
      'Description' => array('Type' => 'Text', 'Caption' => 'Popis', 'Default' => ''),
      'Homepage' => array('Type' => 'Hyperlink', 'Caption' => 'Webové stránky', 'Default' => ''),
      'Type' => array('Type' => 'ServerType', 'Caption' => 'Typ', 'Default' => 0),
      'Database' => array('Type' => 'Database', 'Caption' => 'Databáze', 'Default' => 0),
      'Motd' => array('Type' => 'String', 'Caption' => 'Zpráva dne', 'Default' => 'Vítejte na free WoW serveru'),
      //'TimeCreation' => array('Type' => 'DateTime', 'Caption' => 'Datum založení', 'Default' => 'NOW()'),
    ),
  ),
  'ServerList' => array(
    'Title' => 'Server',
    'Table' => '(SELECT `ClientVersion`.`Version`, `Server`.`Name`, `Server`.`Id`, `Server`.`NetworkPortRealmd`, `User`.`Name` AS `UserName` FROM `Server` JOIN `User` ON `User`.`Id` = `Server`.`User` JOIN `Database` ON `Database`.`Id` = `Server`.`Database` JOIN `Emulator` ON `Emulator`.`Id` = `Database`.`Emulator` JOIN `ClientVersion` ON `ClientVersion`.`Id` = `Emulator`.`ClientVersion`) AS T',
    'Items' => array(
      'Name' => array('Type' => 'String', 'Caption' => 'Název', 'Default' => ''),
      'UserName' => array('Type' => 'String', 'Caption' => 'Správce', 'Default' => ''),
      'NetworkPortRealmd' => array('Type' => 'Integer', 'Caption' => 'Realmd port', 'Default' => ''),
      'Version' => array('Type' => 'Integer', 'Caption' => 'Verze', 'Default' => 0),
      'Online' => array('Type' => 'OnlineState', 'Caption' => 'Stav', 'Default' => 0),
      'CharacterCount' => array('Type' => 'Integer', 'Caption' => 'Hráčů online', 'Default' => 0),
      'AccountCount' => array('Type' => 'Integer', 'Caption' => 'Účtů', 'Default' => 0),
      'CharacterCount' => array('Type' => 'Integer', 'Caption' => 'Postav', 0),
    ),
  ),
  'EmulatorList' => array(
    'Title' => 'Emulátor',
    'Table' => '(SELECT `Emulator`.`Name`, `Emulator`.`Id`, `ClientVersion`.`Version` AS `ClientVersion`, `Emulator`.`Revision`, `Emulator`.`ScriptDev2Revision`, `Emulator`.`ScriptDev2PatchFileName`, `Emulator`.`CommitHash` FROM `Emulator` JOIN `ClientVersion` ON `ClientVersion`.`Id` = `Emulator`.`ClientVersion`) AS T',
    'Items' => array(
      'Name' => array('Type' => 'String', 'Caption' => 'Název', 'Default' => ''),
      'Revision' => array('Type' => 'Integer', 'Caption' => 'Revize', 'Default' => 0),
      'ClientVersion' => array('Type' => 'Integer', 'Caption' => 'Verze klienta', 'Default' => 0),
      'ScriptDev2Revision' => array('Type' => 'Integer', 'Caption' => 'Verze SD2', 'Default' => 0),
      'ScriptDev2PatchFileName' => array('Type' => 'String', 'Caption' => 'SD2 záplata', 'Default' => ''),
      'CommitHash' => array('Type' => 'String', 'Caption' => 'Commit HASH', 'Default' => ''),
    ),
  ),
  'EmulatorItem' => array(
    'Title' => 'Emulátor',
    'Table' => 'Emulator',
    'Items' => array(
      'Name' => array('Type' => 'String', 'Caption' => 'Název', 'Default' => ''),
      'Revision' => array('Type' => 'Integer', 'Caption' => 'Revize', 'Default' => 0),
      //'ClientVersion' => array('Type' => 'PointerOneToOne', 'Caption' => 'Verze klienta', 'Default' => 0),
      'ScriptDev2Revision' => array('Type' => 'Integer', 'Caption' => 'Verze SD2', 'Default' => 0),
      'ScriptDev2PatchFileName' => array('Type' => 'String', 'Caption' => 'SD2 záplata', 'Default' => ''),
      'CommitHash' => array('Type' => 'String', 'Caption' => 'Commit HASH', 'Default' => ''),
    ),
  ),
);

RegisterType('ServerType', 'Enumeration', array('Normální', 'PvP', 'RP', 'RPPvP'));
RegisterType('OnlineState', 'Enumeration', array('Neaktivní', 'Aktivní'));

//RegisterType('Database', 'PointerOneToOne', array('Table' => 'Database', 'Id' => 'Id', 'Name' => 'CONCAT(Name, " ", Version, " r", Revision)'));

?>
