<?php

class MangosDebug extends Module
{
  var $ItemPerPage = 35;
  
  function TimeToHumanTime($Value)
  {
    return(floor($Value / 3600 / 24).' days, '.date('H:i:s', $Value - 3600));
  }

  function ShowPage()
  {
    $Output = '<table width="100%"><tr><td width="10%" valign="top" style="">'.
      '<strong>Restart history:</strong><br />';

    if(array_key_exists('Id', $_GET)) $Id = addslashes($_GET['Id']);
      else $Id = 0;
    if(array_key_exists('Page', $_GET)) $Page = addslashes($_GET['Page']);
      else $Page = 0;

    $DbResult = $this->Database->query('SELECT COUNT(*) FROM Debug');
    $DbRow = $DbResult->fetch_array();
    $Total = $DbRow[0];

    $DbResult = $Database->query('SELECT Id, Time FROM Debug WHERE 1 ORDER BY Time DESC LIMIT '.($Page * $ItemPerPage).','.$ItemPerPage);
    while($DbRow = $DbResult->fetch_array())
    {
      if($DbRow['Id'] == $Id) $Output .= '<strong>';
      $Output .= '<a href="?Id='.$DbRow['Id'].'&amp;Page='.$Page.'&amp;Show=Backtrace">'.str_replace(' ', '&nbsp;', $DbRow['Time']).'</a>';
      if($DbRow['Id'] == $Id) $Output .= '</strong>';
      $Output .= '<br />';
    }
    $Output .= PagesList('?Page=', $Page, $Total, $ItemPerPage, 2);

    $Output .= '</td><td valign="top" width="90%">';

    if($Id > 0)
    {
      $DbResult = $Database->query('SELECT * FROM Debug WHERE Id="'.$Id.'" ORDER BY Time');
      if($DbResult->num_rows > 0)
      {
        $DbRow = $DbResult->fetch_array();
        $Output .= '<strong>Time:</strong> '.$DbRow['Time'].'<br />';
        $Output .= '<strong>MaNGOS version:</strong> '.$DbRow['MangosVersion'].'<br />'; 
        $Output .= '<strong>Database version:</strong> '.$DbRow['DbVersion'].'<br />'; 
        $Output .= '<strong>Uptime:</strong> '.$this->TimeToHumanTime($DbRow['Uptime']).'<br />'; 
        $Output .= '<strong>MaxPlayerCount:</strong> '.$DbRow['MaxPlayerCount'].'<br /><br />'; 
        $Output .= '<a href="?Id='.$Id.'&amp;Page='.$Page.'&amp;Show=Backtrace">Backtrace</a>'.
          '  <a href="?Id='.$Id.'&amp;Page='.$Page.'&amp;Show=Log">Mangos log</a>'.
          '  <a href="?Id='.$Id.'&amp;Page='.$Page.'&amp;Show=Error">Console error log</a>'.
          '  <a href="?Id='.$Id.'&amp;Page='.$Page.'&amp;Show=DbErrors">Database error log</a>'.
          '  <a href="?Id='.$Id.'&amp;Page='.$Page.'&amp;Show=Configuration">Mangos configuration</a>'.
          '<hr>';
        if(array_key_exists('Show', $_GET))
        {
          $Show = addslashes($_GET['Show']);     
          switch($Show)
          {
            case 'Backtrace':
              $Content = htmlspecialchars($DbRow['Backtrace']);
              for($I = 1; $I < $MaxMangosThreadCount; $I++)
              {
                $Content = str_replace('Thread '.$I.' ', '<hr><strong id="'.$I.'">Thread '.$I.'</strong>', $Content);
                $Content = str_replace(' '.$I.' Thread ', '<a href="#'.$I.'"">'.$I.' Thread</a>', $Content);
              }
              $Output .= '<strong>Backtrace:</strong> <br><pre>'.$Content.'</pre>';
              break;
            case 'Log': 
              $Output .= '<strong>Console standard output log:</strong> <br><pre>'.htmlspecialchars($DbRow['Log']).'</pre>';
              break;
            case 'Error': 
              $Output .= '<strong>Console error log:</strong> <br><pre>'.htmlspecialchars($DbRow['ErrorLog']).'</pre>';
              break;
            case 'DbErrors': 
              $Output .= '<strong>Database error log:</strong> <br><pre>'.htmlspecialchars($DbRow['DbErrors']).'</pre>';
              break;
            case 'Configuration': 
              $Output .= '<strong>Mangos configuration:</strong> <br><pre>'.htmlspecialchars($DbRow['Configuration']).'</pre>';
              break;
          }
        }
      }
    }
    $Output .= '</td></tr></table>';
  }
  
  function ProcessLog()
  {
    $Output = '';
    // Read server Id from first parameter
    if((count($_SERVER['argv']) > 1) and is_numeric($_SERVER['argv'][1]))
    {
    $ServerId = $_SERVER['argv'][1];
    $LogDir = '../server/'.$ServerId.'/log/';
    $MangosConfFile = $LogDir.'mangosd.conf';
    $StdOutLogFile = $LogDir.'mangos-worldd.log';
    $ErrOutLogFile = $LogDir.'mangos-worldd.err';
    $MangosLogFile = $LogDir.'Server.log';
    $MangosDbErrorsLogFile = $LogDir.'DBErrors.log';

    if(!file_exists($StdOutLogFile)) exit;
    
    $Content = file_get_contents($StdOutLogFile);
    $Lines = explode("\n", $Content);
    $Content = ''; // Free unused memory

    // Separate information from log file
    $Line = 0;
    while(($Line < count($Lines)) and (substr($Lines[$Line], 0, 6) != 'MaNGOS')) $Line++;
    $MangosVersion = $Lines[$Line];

    // Try to find start of backtrace
    while(($Line < count($Lines)) and (substr($Lines[$Line], 0, 16) != 'Program received')) $Line++;
    $Backtrace = array_slice($Lines, $Line, count($Lines) - $Line);   // Assume rest of file to be backtrace
    $Backtrace = addslashes(implode("\n", $Backtrace));
    $Lines = '';

    //$Log = array_slice($Lines, 0, $Line);
    //$Log = addslashes(implode("\n", $Log));

    // Get used database version from database
    $DbResult = $Database->query('SELECT * FROM `'.$Config['Mangos']['DatabaseMangos'].'`.`db_version`');
    $DbRow = $DbResult->fetch_array();
    $DbVersion = $DbRow['version'];

    // Get last uptime info
    $DbResult = $Database->query('SELECT * FROM `'.$Config['Mangos']['DatabaseRealmd'].'`.`uptime` ORDER BY `starttime` DESC LIMIT 1');
    $Output = $Database->error;
    $DbRow = $DbResult->fetch_array();
    $MaxPlayerCount = $DbRow['maxplayers'];
    $Uptime = $DbRow['uptime'];

    // Insert data to database
    $Database->query('INSERT INTO `Debug` (`Server`, `Time`, `MangosVersion`, `DbVersion`, `Uptime`, `MaxPlayerCount`) VALUES ('.$ServerId.', NOW(), "'.$MangosVersion.'", "'.$DbVersion.'", '.$Uptime.', '.$MaxPlayerCount.')');
    $InsertId = $Database->insert_id;

    // Insert data in separate query to partly avoid too long query packet error
    $Database->query('UPDATE `Debug` SET Backtrace="'.$Backtrace.'" WHERE Id='.$InsertId);
    $Backtrace = '';
    
    if(file_exists($MangosLogFile))
    {
      $Log = addslashes(file_get_contents($MangosLogFile));
      $Database->query('UPDATE `Debug` SET Log="'.$Log.'" WHERE Id='.$InsertId);
      unlink($MangosLogFile);
    
    }
    if(file_exists($MangosDbErrorLogFile))
    {
      $Log = addslashes(file_get_contents($MangosDbErrorsLogFile));
      $Database->query('UPDATE `Debug` SET DbErrors="'.$Log.'" WHERE Id='.$InsertId);
      unlink($MangosDbErrorsLogFile);
    }

    if(file_exists($MangosConfFile))
    {
      $Configuration = array();
      $Log = addslashes(file_get_contents($MangosConfFile));
      $LogLines = explode("\n", $Log);
      foreach($LogLines as $LogLine)
      {
        if(substr($LogLine, 0, 1) != '#') $Configuration[] = $LogLine;
      }
      $Database->query('UPDATE `Debug` SET Configuration="'.implode("\n", $Configuration).'" WHERE Id='.$InsertId);
    }

    if(file_exists($ErrOutLogFile))
    {
      $Log = addslashes(file_get_contents($ErrOutLogFile));
      $Database->query('UPDATE `Debug` SET ErrorLog="'.$Log.'" WHERE Id='.$InsertId);
      unlink($ErrOutLogFile);
    }
    unlink($StdOutLogFile);
    } else $Output = 'Je nutno zadat číslo serveru jako parameter';
    return($Output);
  }
}

?>
