<?php

function ErrorHandler()
{
}
  
class Server extends Module
{
  var $Id;
  var $Server;
  var $WorlddBaseNetworkPort = 8085;
  var $RealmdBaseNetworkPort = 3724;
  var $MangosWorlddThreadCountMax = 12;
  
  function __construct($Database, $Id)
  {
    $this->Database = $Database;
    $this->Id = $Id;
    $DbResult = $this->Database->query('SELECT * FROM `Server` WHERE `Id`='.$Id);
    $this->Server = $DbResult->fetch_assoc();
    $DbResult = $this->Database->query('SELECT * FROM `Database` WHERE `Id`='.$this->Server['Database']);
    if($DbResult->num_rows > 0) $this->Server['Database'] = $DbResult->fetch_assoc();
      else $this->Server['Database'] = array('Emulator' => 0);
    $DbResult = $this->Database->query('SELECT * FROM `Emulator` WHERE `Id`='.$this->Server['Database']['Emulator']);
    if($DbResult->num_rows > 0) $this->Server['Database']['Emulator'] = $DbResult->fetch_assoc();
      else $this->Server['Database']['Emulator'] = array('ClientVersion' => 0);
    $DbResult = $this->Database->query('SELECT * FROM `ClientVersion` WHERE `Id`='.$this->Server['Database']['Emulator']['ClientVersion']);
    if($DbResult->num_rows > 0) $this->Server['Database']['Emulator']['ClientVersion'] = $DbResult->fetch_assoc();
      else $this->Server['Database']['Emulator']['ClientVersion'] = array();
  }
  
  function AddTask($Title, $Task)
  {
    global $System;
    
    $this->Database->insert('Task', array('User' => $System->Modules['User']->User['Id'], 'Title' => $Title, 'Time' => 'NOW()', 'CommandList' => implode("\n", $Task)));
  }
  
  function CreateDatabase()
  {
    $this->Database->query('CREATE DATABASE `server'.$this->Id.'_realmd`');
    $this->Database->query('CREATE DATABASE `server'.$this->Id.'_mangos`');
    $this->Database->query('CREATE DATABASE `server'.$this->Id.'_characters`');
    $this->Database->query('CREATE DATABASE `server'.$this->Id.'_scriptdev2`');
    $this->Database->query('CREATE USER "server'.$this->Id.'"@"localhost" IDENTIFIED BY "server'.$this->Id.'"');
    $this->Database->query('GRANT ALL PRIVILEGES ON `server'.$this->Id.'\_realmd` . * TO "server'.$this->Id.'"@"localhost" WITH GRANT OPTION');
    $this->Database->query('GRANT ALL PRIVILEGES ON `server'.$this->Id.'\_mangos` . * TO "server'.$this->Id.'"@"localhost" WITH GRANT OPTION');
    $this->Database->query('GRANT ALL PRIVILEGES ON `server'.$this->Id.'\_characters` . * TO "server'.$this->Id.'"@"localhost" WITH GRANT OPTION');
    $this->Database->query('GRANT ALL PRIVILEGES ON `server'.$this->Id.'\_scriptdev2` . * TO "server'.$this->Id.'"@"localhost" WITH GRANT OPTION');
  }
  
  function DeleteDatabase()
  {
    $this->Database->query('DROP DATABASE `server'.$this->Id.'_realmd`');
    $this->Database->query('DROP DATABASE `server'.$this->Id.'_mangos`');
    $this->Database->query('DROP DATABASE `server'.$this->Id.'_characters`');
    $this->Database->query('DROP DATABASE `server'.$this->Id.'_scriptdev2`');
    $this->Database->query('DROP USER "server'.$this->Id.'"@"localhost"');
  }
  
  function ImportDatabase($Delete = false)
  {
    $CommandList = array(
      'mysql --user=server'.$this->Id.' --password=server'.$this->Id.' server'.$this->Id.'_mangos < database/'.$this->Server['Database']['Id'].'/'.$this->Server['Database']['SourceFileName'],
      'mysql --user=server'.$this->Id.' --password=server'.$this->Id.' server'.$this->Id.'_scriptdev2 < emulator/'.$this->Server['Database']['Emulator']['Id'].'/source/src/bindings/ScriptDev2/sql/scriptdev2_create_structure.sql',
      'mysql --user=server'.$this->Id.' --password=server'.$this->Id.' server'.$this->Id.'_scriptdev2 < emulator/'.$this->Server['Database']['Emulator']['Id'].'/source/src/bindings/ScriptDev2/sql/scriptdev2_script_full.sql',
      'mysql --user=server'.$this->Id.' --password=server'.$this->Id.' server'.$this->Id.'_mangos < emulator/'.$this->Server['Database']['Emulator']['Id'].'/source/src/bindings/ScriptDev2/sql/mangos_scriptname_full.sql',
      'mysql --user=server'.$this->Id.' --password=server'.$this->Id.' server'.$this->Id.'_realmd < emulator/'.$this->Server['Database']['Emulator']['Id'].'/share/mangos/sql/realmd.sql',
      'mysql --user=server'.$this->Id.' --password=server'.$this->Id.' server'.$this->Id.'_characters < emulator/'.$this->Server['Database']['Emulator']['Id'].'/share/mangos/sql/characters.sql',
    );
    if($Delete == true) 
    {
      array_unshift($CommandList, 'mysql --silent --skip-column-names -u server'.$this->Id.' -pserver'.$this->Id.' server'.$this->Id.'_mangos -e "show tables" | gawk \'{print "drop table " $1 ";"}\' | mysql -u server'.$this->Id.' -pserver'.$this->Id.' server'.$this->Id.'_mangos');
      array_unshift($CommandList, 'mysql --silent --skip-column-names -u server'.$this->Id.' -pserver'.$this->Id.' server'.$this->Id.'_characters -e "show tables" | gawk \'{print "drop table " $1 ";"}\' | mysql -u server'.$this->Id.' -pserver'.$this->Id.' server'.$this->Id.'_characters');
      array_unshift($CommandList, 'mysql --silent --skip-column-names -u server'.$this->Id.' -pserver'.$this->Id.' server'.$this->Id.'_realmd -e "show tables" | gawk \'{print "drop table " $1 ";"}\' | mysql -u server'.$this->Id.' -pserver'.$this->Id.' server'.$this->Id.'_realmd');
      array_unshift($CommandList, 'mysql --silent --skip-column-names -u server'.$this->Id.' -pserver'.$this->Id.' server'.$this->Id.'_scriptdev2 -e "show tables" | gawk \'{print "drop table " $1 ";"}\' | mysql -u server'.$this->Id.' -pserver'.$this->Id.' server'.$this->Id.'_scriptdev2');
    }
    $this->AddTask('Inicializace databáze', $CommandList);
  }
  
  function AddServer($Version)
  {
    
  }
  
  function Start()
  {
    $this->AddTask('Start emulátoru', array(
      'screen -A -m -d -S server'.$this->Id.'-realmd emulator/'.$this->Server['Database']['Emulator']['Id'].'/bin/mangos-realmd -c server/'.$this->Id.'/etc/realmd.conf"',
      'screen -A -m -d -S server'.$this->Id.'-worldd server/'.$this->Id.'/bin/start.sh',
    ));
    return('Požadavek na start serveru zařazen.');
  }
  
  function Stop()
  {
    $this->AddTask('Zastavení emulátoru', array(
      'server/'.$this->Id.'/bin/stop.sh',
    ));
    return('Požadavek na zastavení serveru zařazen.');
  }
  
  function NetworkPortState($Address, $Port, $Timeout = 1)
  {
    set_error_handler('ErrorHandler');
    if($Socket = @fsockopen($Address, $Port, $ERROR_NO, $ERROR_STR, (float)$Timeout))
    {
      fclose($Socket);
      $Result = true;
    } else $Result = false;
    restore_error_handler();
    return($Result);
  }
  
  function GetState()
  {
    $State = array();
    $State['RealmdPortState'] = $this->NetworkPortState('localhost', $this->RealmdBaseNetworkPort + $this->Server['Id']);
    $State['WorlddPortState'] = $this->NetworkPortState('localhost', $this->WorlddBaseNetworkPort + $this->Server['Id']);
    $State['Online'] = $State['RealmdPortState'] and $State['WorlddPortState'];
    $DbResult = $this->Database->query('SELECT COUNT(*) FROM information_schema.TABLES WHERE TABLE_SCHEMA = "server'.$this->Id.'_characters"');
    $DbRow = $DbResult->fetch_row();
    if($DbRow[0] > 0)
    {
      $DbResult = $this->Database->query('SELECT COUNT(*) FROM server'.$this->Id.'_characters.characters AS T WHERE T.online = 1');
      $DbRow = $DbResult->fetch_row();
      $State['OnlinePlayerCount'] = $DbRow[0];
      $DbResult = $this->Database->query('SELECT COUNT(*) FROM server'.$this->Id.'_characters.characters AS T');
      $DbRow = $DbResult->fetch_row();
      $State['CharacterCount'] = $DbRow[0];
      $DbResult = $this->Database->query('SELECT COUNT(*) FROM server'.$this->Id.'_realmd.account AS T');
      $DbRow = $DbResult->fetch_row();
      $State['AccountCount'] = $DbRow[0];
    } else
    {
      $State['OnlinePlayerCount'] = 0;
      $State['CharacterCount'] = 0;
      $State['AccountCount'] = 0;
    }
    return($State);
  }
  
  function UpdateRealmlist()
  {
    global $Config;
    
    $this->Database->query('UPDATE server'.$this->Id.'_realmd.realmlist SET name="'.addslashes($this->Server['Name']).'", address="'.$Config['Web']['Host'].'", port='.($this->WorlddBaseNetworkPort + $this->Id));
  }
  
  function SaveConfiguration()
  {
    $this->SetupConfigurationFiles();
    $this->UpdateRealmlist();
    $this->UpdateScripts();
  }
  
  function UpdateScripts()
  {
    $ServerBinDir = '../server/'.$this->Id.'/bin/';
    if(!file_exists($ServerBinDir)) mkdir($ServerBinDir, 0777, true);    
    
    // GDB script
    $ScriptFileName = '../server/'.$this->Id.'/bin/mangos.gdb';
    $Content = array
    (
      'run -c server/'.$this->Id.'/etc/realmd.conf',
      'info thread',
    );
    for($I = 1; $I < $this->MangosWorlddThreadCountMax; $I++)
    $Content[] = 'thread apply '.$I.' bt full';
    file_put_contents($ScriptFileName, implode("\n", $Content));
    chmod($ScriptFileName, 0666);    

    // Start script
    $ScriptFileName = '../server/'.$this->Id.'/bin/start.sh';
    $Content = array
    (
      '#!/bin/sh',
      'while [ 1=1 ] ; do',
      'gdb emulator/'.$this->Id.'/bin/mangos-realmd -x mangos.gdb --batch >>server/'.$this->Id.'/log/mangos-worldd.log 2>>server/'.$this->Id.'/log/mangos-worldd.err',
      'cd www',
      'php mangos_debug_process.php '.$this->Id.' >>server/'.$this->Id.'/log/mangos_debug.log 2>>server/'.$this->Id.'/log/mangos_debug.err',
      'cd ..',
      'sleep 3',
      'done',
    );
    file_put_contents($ScriptFileName, implode("\n", $Content));
    chmod($ScriptFileName, 0777);    

    // Stop script
    $ScriptFileName = '../server/'.$this->Id.'/bin/stop.sh';
    $Content = array
    (
      '#!/bin/sh',
      'ps -ef | grep \'SCREEN -A -m -d -S server'.$this->Id.'-realmd\' | grep -v grep | awk \'{print $2}\' | xargs -i kill {}',
      'ps -ef | grep \'SCREEN -A -m -d -S server'.$this->Id.'-worldd\' | grep -v grep | awk \'{print $2}\' | xargs -i kill {}',
    );
    file_put_contents($ScriptFileName, implode("\n", $Content));
    chmod($ScriptFileName, 0777);    
  }
  
  function SetupConfigurationFiles()
  {
    $EmulatorEtcDir = '../emulator/'.$this->Server['Database']['Emulator']['Id'].'/etc/';
    $ServerEtcDir = '../server/'.$this->Id.'/etc/';
    $ServerLogDir = '../server/'.$this->Id.'/log/';
    if(!file_exists($ServerEtcDir)) mkdir($ServerEtcDir, 0777, true);    
    if(!file_exists($ServerLogDir)) mkdir($ServerLogDir, 0777, true);    
    
    // mangosd.conf
    $Config = new MangosConfigurationFile($this->Database);
    $Config->Load($EmulatorEtcDir.'mangosd.conf.dist');
    $Config->ParameterList['LoginDatabaseInfo'] = 'localhost;3306;server'.$this->Id.';server'.$this->Id.';server'.$this->Id.'_realmd';
    $Config->ParameterList['WorldDatabaseInfo'] = 'localhost;3306;server'.$this->Id.';server'.$this->Id.';server'.$this->Id.'_mangos';
    $Config->ParameterList['CharacterDatabaseInfo'] = 'localhost;3306;server'.$this->Id.';server'.$this->Id.';server'.$this->Id.'_characters';
    $Config->ParameterList['ScriptDev2DatabaseInfo'] = 'localhost;3306;server'.$this->Id.';server'.$this->Id.';server'.$this->Id.'_scriptdev2';
    $Config->ParameterList['WorldServerPort'] = $this->WorlddBaseNetworkPort + $this->Id;
    $Config->ParameterList['Motd'] = $this->Server['Motd'];
    $Config->ParameterList['DataDir'] = 'wowclient/'.$this->Server['Database']['Emulator']['ClientVersion']['Version'];
    $Config->ParameterList['LogsDir'] = 'server/'.$this->Id.'/log';
    $ServerTypes = array(0 => 0, 1 => 1, 2 => 6, 3 => 8);
    $Config->ParameterList['GameType'] = $ServerTypes[$this->Server['Type']];
    $Config->Save($ServerEtcDir.'mangosd.conf');
   
    // realmd.conf
    $Config = new MangosConfigurationFile($this->Database);
    $Config->Load($EmulatorEtcDir.'realmd.conf.dist');
    $Config->ParameterList['LoginDatabaseInfo'] = 'localhost;3306;server'.$this->Id.';server'.$this->Id.';server'.$this->Id.'_realmd';
    $Config->ParameterList['RealmServerPort'] = $this->RealmdBaseNetworkPort + $this->Id;
    $Config->ParameterList['LogsDir'] = 'server/'.$this->Id.'/log';
    $Config->Save($ServerEtcDir.'realmd.conf');
   
    // scriptdev2.conf
    $Config = new MangosConfigurationFile($this->Database);
    $Config->Load($EmulatorEtcDir.'scriptdev2.conf');
    $Config->ParameterList['ScriptDev2DatabaseInfo'] = 'localhost;3306;server'.$this->Id.';server'.$this->Id.';server'.$this->Id.'_scriptdev2';
    $Config->Save($ServerEtcDir.'scriptdev2.conf');  
  }
}

?>
